| Face Engine SDK 5.12.0 A face detection, recognition and tracking engine.

Public Member Functions | List of all members
fsdk::ICrowdEstimator Struct Referenceabstract

Crowd estimator interface. More...

`#include <ICrowdEstimator.h>`

Inheritance diagram for fsdk::ICrowdEstimator:

## Public Member Functions
virtual Result< FSDKError > | estimate (const Image &image, const Rect &rect, CrowdEstimation &estimation) const noexcept=0
| Estimates the crowd on the target image. More...
virtual Result< FSDKError > | estimate (Span< const Image > images, Span< const Rect > rects, Span< CrowdEstimation > estimations) const noexcept=0
| Estimates the the crowd on multiple images in a single estimate function call. More...
virtual Result< FSDKError > | validate (Span< const Image > images, Span< const Rect > rects, Span< Result< FSDKError >> errors) const noexcept=0
| Validate input of multiple frames in a single function call. More...
virtual CrowdEstimatorType | getType () const noexcept=0
| Returns a type of the estimator. More...
Public Member Functions inherited from fsdk::IRefCounted
virtual int32_t | retain () noexcept=0
| Increase strong reference count. More...
virtual int32_t | retainLocked () noexcept=0
| Increase strong reference count thread safely. More...
virtual int32_t | release () noexcept=0
| Decrease strong reference count. More...
virtual int32_t | getRefCount () const noexcept=0
| Get actual strong reference count. More...
virtual int32_t | retainWeak () noexcept=0
| Increase weak reference count. More...
virtual int32_t | releaseWeak () noexcept=0
| Decrease weak reference count. More...
virtual int32_t | getWeakRefCount () const noexcept=0
| Get actual weak reference count. More...

## Detailed Description

Crowd estimator interface.

Note
  This estimator is designed to work with an image or with a batch of images. Crowd estimator returns the number of peoples (heads) on the image.

See also
  CrowdEstimation for output details.

## Member Function Documentation

## ◆ estimate() [1/2]

virtual Result<FSDKError> fsdk::ICrowdEstimator::estimate | ( | const Image & | image,
|  | const Rect & | rect,
|  | CrowdEstimation & | estimation
| ) |  | const
| pure virtual noexcept

Estimates the crowd on the target image.

Parameters

  [in] | image | source image. Format must be R8G8B8.
  [in] | rect | rectangle of interest in the image.
  [out] | estimation | estimation of crowd.

See also
  CrowdEstimation for details

Returns
  Result with error code.

See also
  CrowdEstimation, Image, Rect, Result and FSDKError for details.

## ◆ estimate() [2/2]

virtual Result<FSDKError> fsdk::ICrowdEstimator::estimate | ( | Span< const Image > | images,
|  | Span< const Rect > | rects,
|  | Span< CrowdEstimation > | estimations
| ) |  | const
| pure virtual noexcept

Estimates the the crowd on multiple images in a single estimate function call.

Parameters

  [in] | images | span of source images. Format must be R8G8B8.
  [in] | rects | input rectangles of interest (ROI) span.
  [out] | estimations | output CrowdEstimation span.

See also
  CrowdEstimation for details

Returns
  Result with error code.

See also
  Span, CrowdEstimation, Image, Rect, Result and FSDKError for details.

Note
  images format must be R8G8B8,

See also
  Format.

Note
  all spans should be based on user owned continuous collections.
  all spans should be equal size.

## ◆ getType()

virtual CrowdEstimatorType fsdk::ICrowdEstimator::getType | ( |  | ) | const
| pure virtual noexcept

Returns a type of the estimator.

Returns
  Type of the estimator.

See also
  CrowdEstimatorType

## ◆ validate()

virtual Result<FSDKError> fsdk::ICrowdEstimator::validate | ( | Span< const Image > | images,
|  | Span< const Rect > | rects,
|  | Span< Result< FSDKError >> | errors
| ) |  | const
| pure virtual noexcept

Validate input of multiple frames in a single function call.

Parameters

  [in] | images | span of source images.
  [in] | rects | span of rectangle coordinates of corresponding source images.
  [out] | errors | output span of errors for each image.

Returns
  Result with error code.

See also
  Span, Image, Rect, Result and FSDKError for details.

Note
  images format must be R8G8B8,

See also
  Format.

Note
  all spans should be based on user owned continuous collections.
  all spans should be equal size.

The documentation for this struct was generated from the following file:

- include/fsdk/Estimators/ICrowdEstimator.h